use lazy_static::lazy_static;
use std::sync::Mutex;

#[cfg(not(debug_assertions))]
const db_path : &str ="/opt/mini_admin_bot/data.db";

#[cfg(debug_assertions)]
const db_path : &str ="polesDB";

#[cfg(not(test))]
lazy_static! {
    pub static ref DB_CONNECTION : Mutex<Box<sqlite::Connection>> =
        Mutex::new(Box::new(sqlite::open(db_path).unwrap()));
}

#[cfg(test)]
lazy_static! {
    pub static ref DB_CONNECTION : Mutex<Box<sqlite::Connection>> =
        Mutex::new(Box::new(sqlite::open("polesDBTest").unwrap()));
}
